unit uViewFacturaCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uViewBase, DB, uDADataTable, uCustomView,
  uBizFacturasCliente,
  cxControls, cxContainer, cxEdit, cxTextEdit, cxDBEdit, dxLayoutControl,
  cxMemo, cxMaskEdit, cxDropDownEdit, cxCalendar, cxSpinEdit, StdCtrls, Mask,
  DBCtrls, cxGraphics, dxLayoutLookAndFeels, cxLookupEdit, cxDBLookupEdit,
  cxDBLookupComboBox, uFormasPagoController, uDAInterfaces, uBizFormasPago,
  ActnList, uViewDatosYSeleccionClienteFacturaCliente;

type
  IViewFacturaCliente = interface(IViewBase)
  ['{3A95930C-20B3-41E9-93CB-21138ADB5B70}']
    function GetFactura: IBizFacturaCliente;
    procedure SetFactura(const Value: IBizFacturaCliente);
    property Factura: IBizFacturaCliente read GetFactura write SetFactura;

    function GetViewClienteFactura: IViewDatosYSeleccionClienteFacturaCliente;
    property ViewClienteFactura: IViewDatosYSeleccionClienteFacturaCliente read GetViewClienteFactura;
  end;

  TfrViewFacturaCliente = class(TfrViewBase, IViewFacturaCliente)
    DADataSource: TDADataSource;
    dxLayoutControl1Group_Root: TdxLayoutGroup;
    dxLayoutControl1: TdxLayoutControl;
    dxLayoutControl1Item1: TdxLayoutItem;
    eReferencia: TcxDBTextEdit;
    dxLayoutControl1Item2: TdxLayoutItem;
    edtFecha: TcxDBDateEdit;
    dxLayoutControl1Group1: TdxLayoutGroup;
    dxLayoutControl1Group2: TdxLayoutGroup;
    dxLayoutControl1Item5: TdxLayoutItem;
    memObservaciones: TcxDBMemo;
    dxLayoutControl1Group5: TdxLayoutGroup;
    dxLayoutControl1Item6: TdxLayoutItem;
    dxLayoutLookAndFeelList1: TdxLayoutLookAndFeelList;
    dxLayoutOfficeLookAndFeel1: TdxLayoutOfficeLookAndFeel;
    dsFormaPago: TDADataSource;
    dxLayoutControl1Item4: TdxLayoutItem;
    cbFormaPago: TcxDBLookupComboBox;
    dxLayoutControl1Item10: TdxLayoutItem;
    bFormasPago: TButton;
    dxLayoutControl1Group3: TdxLayoutGroup;
    dxLayoutControl1Item3: TdxLayoutItem;
    cbCuentaBancaria: TcxDBComboBox;
    dxLayoutControl1Group4: TdxLayoutGroup;
    dxLayoutControl1Item7: TdxLayoutItem;
    Label1: TLabel;
    dxLayoutControl1Item8: TdxLayoutItem;
    cbClienteFinal: TcxDBTextEdit;
    dxLayoutControl1Item9: TdxLayoutItem;
    bElegirClienteFinal: TButton;
    dxLayoutControl1Group7: TdxLayoutGroup;
    dxLayoutControl1Group8: TdxLayoutGroup;
    ActionList1: TActionList;
    actElegirClienteFinal: TAction;
    frViewDatosYSeleccionClienteFacturaCliente1: TfrViewDatosYSeleccionClienteFacturaCliente;
    dxLayoutControl1Group9: TdxLayoutGroup;
    procedure bFormasPagoClick(Sender: TObject);
    procedure CustomViewDestroy(Sender: TObject);
    procedure CustomViewCreate(Sender: TObject);
    procedure actElegirClienteFinalExecute(Sender: TObject);
    procedure actElegirClienteFinalUpdate(Sender: TObject);
  protected
    FFactura : IBizFacturaCliente;
    FFormasPago : IBizFormaPago;
    FFormasPagoController : IFormasPagoController;
    FViewClienteFactura : IViewDatosYSeleccionClienteFacturaCliente;
    function GetFactura: IBizFacturaCliente;
    procedure SetFactura(const Value: IBizFacturaCliente);
    procedure RellenarCuentasBancarias;

    function GetViewClienteFactura: IViewDatosYSeleccionClienteFacturaCliente;
  public
    property Factura: IBizFacturaCliente read GetFactura write SetFactura;
    property ViewClienteFactura: IViewDatosYSeleccionClienteFacturaCliente read GetViewClienteFactura;
  end;


implementation

uses
  uDataModuleContactos, schFacturasClienteClient_Intf, uFactuGES_App,
  uEmpresasController, uClientesController, uBizContactos, uBizDireccionesContacto;

{$R *.dfm}

{ TfrViewFacturaCliente }

procedure TfrViewFacturaCliente.actElegirClienteFinalExecute(Sender: TObject);
var
  ACliente : IBizCliente;
  AClienteController : IClientesController;
begin
  inherited;
  AClienteController := TClientesController.Create;
  try
    ACliente := (AClienteController.ElegirContacto(AClienteController.BuscarTodos,
      'Elija el cliente final de esta factura', False) as IBizCliente);
    if Assigned(ACliente) then
    begin
      ShowHourglassCursor;
      try
        FFactura.Edit;
        FFactura.CLIENTE_FINAL := ACliente.NOMBRE;
      finally
        HideHourglassCursor;
      end;
    end;
  finally
    ACliente := NIL;
    AClienteController := NIL;
  end;
end;

procedure TfrViewFacturaCliente.actElegirClienteFinalUpdate(Sender: TObject);
begin
  inherited;
  (Sender as TAction).Enabled := (not ReadOnly);
end;

procedure TfrViewFacturaCliente.bFormasPagoClick(Sender: TObject);
begin
  inherited;
  if Assigned(FFormasPago) then
     FFormasPagoController.VerTodos(FFormasPago);
end;

procedure TfrViewFacturaCliente.CustomViewCreate(Sender: TObject);
begin
  inherited;
  FFormasPago := Nil;
  FFormasPagoController := TFormasPagoController.Create;
  FViewClienteFactura := frViewDatosYSeleccionClienteFacturaCliente1;
end;

procedure TfrViewFacturaCliente.CustomViewDestroy(Sender: TObject);
begin
  inherited;
  FFormasPago := Nil;
  FFormasPagoController := NIL;
  FViewClienteFactura := NIL;
end;

function TfrViewFacturaCliente.GetFactura: IBizFacturaCliente;
begin
  Result := FFactura;
end;

function TfrViewFacturaCliente.GetViewClienteFactura: IViewDatosYSeleccionClienteFacturaCliente;
begin
  Result := FViewClienteFactura;
end;

procedure TfrViewFacturaCliente.RellenarCuentasBancarias;
var
  AController : IEmpresasController;
  ALista : TStringList;
  AListaIBAN : TStringList;
  i : integer;
begin
  AController := TEmpresasController.Create;
  try
    ALista := AController.DarListaCuentasBancarias(AppFactuGES.EmpresaActiva);
    AListaIBAN := AController.DarListaCuentasBancariasIBAN(AppFactuGES.EmpresaActiva);
    try
      with cbCuentaBancaria.Properties.Items do
      begin
        BeginUpdate;
        try
          Clear;
          Add('');
          for i := 0 to ALista.Count - 1 do
            Add(ALista.Names[i]);

          if AListaIBAN.Count > 0 then
          begin
            Add('--------------');
            for i := 0 to AListaIBAN.Count - 1 do
              Add(AListaIBAN.Names[i]);
          end;
        finally
          EndUpdate;
        end;
      end;
    finally
      FreeANDNIL(ALista);
      FreeANDNIL(AListaIBAN);      
    end;
  finally
    AController := NIL;
  end;
end;

procedure TfrViewFacturaCliente.SetFactura(const Value: IBizFacturaCliente);
var
  ACadena : String;
begin
  FFactura := Value;
  RellenarCuentasBancarias;

  if Assigned(FFactura) then
  begin
    DADataSource.DataTable := FFactura.DataTable;

    frViewDatosYSeleccionClienteFacturaCliente1.Factura := FFactura;
    frViewDatosYSeleccionClienteFacturaCliente1.Cliente := FFactura.Cliente;

    FFormasPago := FFormasPagoController.BuscarTodos;
    dsFormaPago.DataTable := FFormasPago.DataTable;
    dsFormaPago.DataTable.Active := True;

    if FFactura.TIPO = CTE_TIPO_ABONO then
    begin
      dxLayoutControl1Group1.Caption := 'Datos del abono:';
      dxLayoutControl1Item2.Caption := 'Fecha del abono:';
      ACadena := 'Elija el cliente al que se le realizará el abono.';
    end
    else
      ACadena := 'Elija el cliente al que se le realizará la factura.';
    //ViewDatosYSeleccionClienteFacturaCliente1.MsgElegirCliente := ACadena;
  end
  else begin
    DADataSource.DataTable := NIL;
    dsFormaPago.DataTable := NIL;
    frViewDatosYSeleccionClienteFacturaCliente1.Factura := NIL;
    frViewDatosYSeleccionClienteFacturaCliente1.Cliente := NIL;
  end;
end;

end.
